MAXScript Language Reference > 3ds Max Objects > Modifier : MAXWrapper and SpacewarpModifier : MAXWrapper > Modifier and SpacewarpModifier Types > Modifiers > Subdivision Surfaces >

# HSDS_Modifier - superclass: modifier

    HSDS_Modifier - superclass: modifier; super-superclass:MAXWrapper - 15:0 - classID: #(341062, 28997)

Value > MAXWrapper > Modifier > HSDS_Modifier

| Modifier Classes - Quick Navigation

Constructor

    HSDS_Modifier ... HSDS ...

NoteThe HSDS_Modifier class is exposed as HSDS in 3ds Max 5 and higher. Both the old and the new constructor will work, so existing scripts should remain compatible. Testing the class using classof will return true for both HSDS_Modifier and HSDS. Also note that there are a couple of new properties in 3ds Max 5 and higher described at the bottom of the Properties list.

Properties

    <HSDS_Modifier>.levelOfDetail Integer default: 0 -- integer; LOD

Shows the current level of the subdivision hierarchy. Automatically increments when you subdivide a sub-object selection. To edit at a different level of detail, change the setting to the desired level.

    <HSDS_Modifier>.matId Integer default: 1 -- integer; Material_Id

Displays the material ID assigned to the current selection. Available only in Polygon and Element sub-object modes. If multiple sub-objects are selected and they don't share an ID, this field is blank.

    <HSDS_Modifier>.ignoreBackface Boolean default: false -- boolean; Ignore_Backface

When on, you can select only those sub-objects whose normals are visible in the viewport. When off (the default), selection includes all sub-objects, regardless of the direction of their normals.

    <HSDS_Modifier>.useSoftSel Boolean default: false -- boolean; Use_Soft_Selection

These controls let you set a gradual falloff of influence between selected and unselected vertices. See Soft Selection Rollout (Edit/Editable Mesh).

Vertex Interpolation rollout

Determines how selected vertices are treated during subdivision. Available only in Vertex sub-object mode.

For best results, use when moving control grid vertices at a level of detail lower than the highest in which the vertex resides.

    <HSDS_Modifier>.useEdgeDist Boolean default: false -- boolean; Use_Edge_Distance

    <HSDS_Modifier>.affectBackface Boolean default: false -- boolean; Affect_Backface

When on, deselected sub-objects whose normals (or, in the case of vertices and edges, the normals of faces to which they're attached) are facing in the opposite direction to the average normal of the selected sub-objects, are affected by the soft selection influence. Turn off Affect Backfacing when you want to pull faces of a thin object, such as a thin box, but don't want to affect faces on the other side of the object.

Note

Affect Backfacing is not available when editing splines.

When using Edit/Editable Mesh, you can also use the keyboard shortcut Ctrl+F to toggle Affect Backfacing (while the Keyboard Shortcut Override Toggle button is turned on).

    <HSDS_Modifier>.edgeDistance Integer default: 1 -- integer; Edge_Dist

This spinner setting limits the region affected by the number of edges between the selection and the affected vertices. The affected region is measured in terms of "edge-distance" space, along the surface, rather than real space.

    <HSDS_Modifier>.falloff Float default: 20.0 -- float

Distance in current units from the center to the edge of a sphere defining the affected region. Use higher falloff settings to achieve more gradual slopes, depending on the scale of your geometry. Default=20.

Note

At the Vertex sub-object level, the region specified by the Falloff setting is depicted graphically in the viewports as a vertex-color gradient from the Sub-selection color (normally red) to the Vertex Ticks color (normally blue). In addition, this gradient is updated in real time as you change the Falloff setting.

    <HSDS_Modifier>.pinch Float default: 0.0 -- float

Raises and lowers the top point of the curve along the vertical axis. Sets the relative "pointedness" of the region. When negative, a crater is produced instead of a point. At a setting of 0, Pinch produces a smooth transition across this axis. Default=0.

    <HSDS_Modifier>.bubble Float default: 0.0 -- float

Expands and contracts the curve along the vertical axis. Sets the relative "fullness" of the region. Limited by Pinch, which sets a fixed starting point for Bubble. A setting of 0 for Pinch and 1.0 for Bubble produces a maximum smooth bulge. Negative values for Bubble move the bottom of the curve below the surface, creating a "valley" around the base of the region. Default=0.

    <HSDS_Modifier>.vertexType Integer default: 0 -- integer; Vertex_Type]

Standard/Conic/Cusp/Corner:

Determines how closely mesh vertices follow the movement of control grid vertices. Standard provides the least amount of relative movement, while Cusp and Corner provide the most. Corner also more closely matches mesh edges to the control grid edges attached to the moved vertex. Default=Standard.

The following additional properties have been exposed in 3ds Max 5:

    <HSDS_Modifier>.crease Float default: 0.0 -- float

Controls the Edge Crease value.

    <HSDS_Modifier>.displayLevel Integer default: 0 -- integer; Display_Level

Returns the current display level

    <HSDS_Modifier>.onlyCurrentLevel Boolean default: false -- boolean; Only_Current_Level

When set to true, only the current level will be displayed.

    <HSDS_Modifier>.smoothResult Boolean default: true -- boolean; Smooth_Result

When set to true, the resulting mesh will be smoothed.

REMOVED:
The following property was available in 3ds Max 4 but is not available in 3ds Max 5 and higher:

    <HSDS_Modifier>.shadedLattice Boolean default: false -- boolean; Shaded_Lattice

Displays only polygons at the current level of detail, with highlights, but without smoothing. Use this option to speed up the display when working with complex objects. Default=off.

HSDS_Modifier interfaces:

    Interface: hsdsOps

Methods

    <void>subdivide()

    <void>deletePolygon()

    <void>hide()

    <void>showAll()

    <void>createNamedSelection <string>name

    <void>activateNamedSelection <string>name

    <void>addDetail <float>length<float>angle

    <void>removeDetail <float>length<float>angle

    <void>setDetailPrecision <float>p

#### See Also

- TurboSmooth : Modifier

- MeshSmooth : Modifier

- Quadify_Mesh : Modifier

- Subdivide : Modifier

- Tessellate : Modifier

- Modifier Common Properties, Operators, and Methods

- MAXWrapper Common Properties, Operators, and Methods

- Value Common Properties, Operators, and Methods